<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:53 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>copy</name>
<version>1.0</version>
<signature>array array</signature>
<help>
Copies a file from fonality's HTTP server to this server using an HTTP GET
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       copy
#
#   Description:    Downloads a remote file over HTTP to the specified path
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        1=success undef=faulure
#
###############################################################################
sub copy
{
	my ($srv, $req) = @_;

open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: copy.xpl(@_)\n"; close(LOG);
	use strict;
	use LWP::Simple;
	use File::Basename;
	use Fcntl ':flock';
	use Digest::MD5;

	my ($url, $file, $md5) = @{$req};
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: copy.xpl: $url, $file, $md5\n"; close(LOG);

	unless ($url)
	{
		return "No URL specified";
	}
	unless ($file)
	{
		return "No file specified";
	}

	unless ($md5)
	{
		return "No md5 specified";
	}

	my $copyfile = $file . ".copy";

	# allowed path
	if ($file !~ m;^(/data/\d*)?(/var/lib/asterisk|/etc/asterisk|/var/spool/asterisk|/tftpboot);)
	{
		return "Cannot allow you to write to that directory";
	}

	# check if the md5 sum of the file matches the md5 of the file they want to sync
	if (open(FILE, "<$file"))
	{
		if (md5_hex(<FILE>) eq $md5)
		{                                                                                                     
			close(FILE);     			
			return 1;                                                                                         
		}                                                                                                     
		close(FILE);                                                                                          
	}

	# Make the directory if it does not exist
	my($dirname) = dirname($file);
	my($d);
	unless(-d $dirname) { # Make the directory if needed
		my(@path_ary) = split(/\//, $dirname);
		foreach(1..scalar(@path_ary)) {
			my($p) = shift(@path_ary);
			$d  .= "/$p";
			unless(-d $d) {
				mkdir($d);
			}
		}
	}

	# Create a lockfile to prevent simelaneous writes
	my $copylockfile = $copyfile . ".lck";

	open(COPYLOCKFILE, ">$copylockfile") || return "COPY Failed: Can't open lockfile $copylockfile for writing: $!";
	flock(COPYLOCKFILE,LOCK_EX);

	# Execute the wget
	my($rv) = getstore($url, $copyfile);
	if($rv == 200) {

		# get the md5sum of the file
		open(MD5FILE, $copyfile) || return "COPY Failed: Can't open $copyfile: $!";
		binmode(MD5FILE);
	
		my $localmd5 = Digest::MD5->new->addfile(*MD5FILE)->hexdigest;

		close(MD5FILE);

		if (($md5 !~ /\w{32}/) || ($md5 ne $localmd5)) {
			# Remove the bad copy file
			if (-e $copyfile) {
				unlink($copyfile);
			}
			close(COPYLOCKFILE);
			unlink($copylockfile);
			return("MD5 Failed: $rv=rv url=$url file=$copyfile remote_md5=$md5 local_md5=$localmd5");
		}

		close(COPYLOCKFILE);
		unlink($copylockfile);

		# The file arrived at the host machine and passed the md5 check
		# Now replace the real file with this new file
		# check for a lck file before preceeding

		my $lockfile = $file . ".lck";

		open(LOCKFILE, ">$lockfile") || return "COPY Failed: Can't open lockfile $lockfile for writing: $!";
		flock(LOCKFILE,LOCK_EX);
		
		copy($copyfile,$file);

		if (-e $copyfile)
		{
			unlink($copyfile);
		}

		close(LOCKFILE);
		unlink($lockfile);

		return(1);
	}
	else {
		close(COPYLOCKFILE);
		unlink($copylockfile);

		return("HTTP GET Failed: rv=$rv url=$url file=$file");
	}

}


__END__
]]></code>
</methoddef>
