<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:53 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>get_context</name>
<version>1.1</version>
<signature>array string</signature>
<help>
##############################################################################
# get_context: Get all relevant info in this context for display/editing
#
#    Args: scalar_name_of_context_to_get
# Returns: arrayref_to_array_of_hashrefs | undef if nonexistant
##############################################################################
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
##############################################################################
# get_context: Get all relevant info in this context for display/editing
#
#    Args: scalar_name_of_context_to_get
# Returns: arrayref_to_array_of_hashrefs | undef if nonexistant
##############################################################################
sub get_context {
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: get_context.xpl(@_)\n"; close(LOG);
	require "/var/www/rpc/strip.pl";

	my $srv = shift;
	my($context) = shift(@_) || die "Context name missing";
	my($dir) = '/etc/asterisk/fonality';
	my($file) = "${dir}/${context}.conf";
	my(@array_of_hashrefs);

	$context = strip_nasties($context); # Clean out any bad characters
	unless(-f $file) {
		die "$file does not exist";
	}
	open(FILE, $file) || die "Can't open: $file because: $!";
	while(<FILE>) {
		if(/^exten\s+=>\s+(\S.*)/) {
			my($text) = $1;
			chomp($text);
			my(@items) = split(/\,/, $text);
			my($extn) = shift(@items);
			my($priority) = shift(@items);
			my($app) = join(',', @items);
			my($comment);
			if($app =~ /;(.*)/) {
				$comment = $1;
				$app =~ s/$comment//;
			}
			push(@array_of_hashrefs, 
				{ 
					'extn' => $extn,
					'priority' => $priority,
					'app' => $app,
					'comment' => $comment
				}
			);
		}
	}
	close(FILE);
	return(\@array_of_hashrefs);
}

__END__
]]></code>
</methoddef>
