<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Wed Aug 25 14:30:52 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>get_include_list</name>
<version>1.1</version>
<signature>array string</signature>
<help>
##############################################################################
# get_include_list: Get a list of all the files included in the given file
#
#    Args: scalar_name_of_file_to_look_in
# Returns: arrayref_of_file_names
##############################################################################
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
##############################################################################
# get_include_list: Get a list of all the files included in the given file
#
#    Args: scalar_name_of_file_to_look_in
# Returns: arrayref_of_file_names
##############################################################################
sub get_include_list {
	my $srv = shift;
	my($file) = shift(@_) || '/etc/asterisk/extensions.conf';
	my($names) = shift(@_);
	my(@list);

	unless (-e $file)
	{
		if (-e "/etc/asterisk/$file")
		{
			$file = "/etc/asterisk/$file";
		}
		else
		{
			die "No such file $file";
		}
	}

	#print "Opening $file\n";
	open(local(*EC), $file) || die "Can't open $file: $!";
	while(<EC>) {
		chomp($_);
		if(/^#include "(\S+)"/) {
			my($file) = $1;
			if(!defined($names->{$file})) {
				push(@list, $file);
				$names->{$file}++; # Prevent duplicate inclusion
				# Recurse included file
				push(@list, @{&get_include_list($srv,$file,$names)}); 
			}
		}
	}
	close(EC);
	return(\@list);
}

__END__
]]></code>
</methoddef>
