<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:54 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>restart_phone</name>
<version>1.0</version>
<signature>array int</signature>
<help>
Restart a phone by ext.
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       restart_phone
#
#   Description:    Restart a phone
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#                   $extension     in      string    extension
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        Results 1 or undef
#
###############################################################################
use strict;
use warnings;

use LWP::UserAgent;
use HTTP::Cookies;

sub restart_phone
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: restart_phone.xpl(@_)\n"; close(LOG);

	my ($srv, $ext_number) = @_;	
	my $mac_add;
	
	READFILES: for ('internal', 'external') 
	{
       	open my $conf, '<', "/etc/asterisk/fonality/$_.conf" or die "$!";
       	while (my $line = <$conf>) 
		{
			my ($ext, $mac) = $line =~ m/(\d+),\d+,Dial\(SIP\/(\w+)/;
			if(($mac) && ($ext eq $ext_number))
			{
				$mac_add = $mac;
				
				close $conf;				
				last READFILES;
			}
		}
		close $conf;
	}

	return undef unless $mac_add;	

	# get ip by mac form asterisk
	my $out = `/usr/sbin/asterisk -rx "sip show peer $mac_add"`;
	my ($ip) = $out =~ m/Addr->IP\s+:\s(\S+)\s/;

	return undef unless $ip;	
	
	# reboot astra phone by mac address
	if($mac_add =~ /^00085D/)
	{
		my $browser = LWP::UserAgent->new;
		my $cookie_jar = HTTP::Cookies->new();
		
		$browser->cookie_jar($cookie_jar);
		$browser->timeout(30); 	

		# default aastra username and password (and long realm from astra)
		$browser->credentials("$ip:80",'Please enter User name and password','admin' => '22222');

		# set a cookies to cookie jar with first url
		my $resp = $browser->get("http://$ip/");
		$resp = $browser->post( "http://$ip/reset.html",['resetOption'=>'0']);	

		if( $resp->content =~ m/Restarting/ ){
			return 1;
		}
		else{
			return undef;
		}
	}
	else{
		return undef;
	}

}

__END__
]]></code>
</methoddef>
